com.smartgwt.client.widgets.form.fields

## Class DateTimeItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.form.fields.FormItem
        - - com.smartgwt.client.widgets.form.fields.DateItem
          - - com.smartgwt.client.widgets.form.fields.DateTimeItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPickerIconClickHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers

      public class DateTimeItem
      extends DateItem

  Subclass of DateItem for manipulating `datetimes`.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DateTimeItem()`
    `DateTimeItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `DateTimeItem(java.lang.String name)`
    `DateTimeItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `DateDisplayFormat` | `getDisplayFormat()` This property can be used to customize the format in which datetimes are displayed. Should be set to a standard `DateDisplayFormat` or a function which will return a formatted date time string.
    `java.lang.String` | `getInputFormat()` If `useTextField` is `true` this property can be used to specify the input format for date strings.
    `static DateTimeItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.Boolean` | `getUseTextField()` DateTimeItems show datetime values in a freeform text entry area.
    `static void` | `setDefaultProperties(DateTimeItem dateTimeItemProperties)` Class level method to set the default properties of this class.
    `void` | `setDisplayFormat(DateDisplayFormat displayFormat)` This property can be used to customize the format in which datetimes are displayed. Should be set to a standard `DateDisplayFormat` or a function which will return a formatted date time string.
    `void` | `setInputFormat(java.lang.String inputFormat)` If `useTextField` is `true` this property can be used to specify the input format for date strings.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setUseTextField(java.lang.Boolean useTextField)` DateTimeItems show datetime values in a freeform text entry area.

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.DateItem

      `deselectValue, deselectValue, getCenturyThreshold, getDateFormatter, getDaySelector, getDaySelectorProperties, getDefaultChooserDate, getEndDate, getEnforceDate, getEnteredValue, getFiscalCalendar, getInvalidDateStringMessage, getMonthSelector, getMonthSelectorProperties, getPickerIconPrompt, getPickerProperties, getPickerTimeItemProperties, getSelectionRange, getSelectorFormat, getShowChooserFiscalYearPicker, getShowChooserWeekPicker, getShowPickerTimeItem, getStartDate, getTextAlign, getTextField, getTextFieldProperties, getUse24HourTime, getUseSharedPicker, getValueAsDate, getYearSelector, getYearSelectorProperties, selectValue, setCenturyThreshold, setDateFormatter, setDaySelectorProperties, setDefaultChooserDate, setDefaultProperties, setEditorValueFormatter, setEditorValueParser, setEndDate, setEnforceDate, setFiscalCalendar, setFiscalCalendar, setInvalidDateStringMessage, setMaskDateSeparator, setMonthSelectorProperties, setPickerIconPrompt, setPickerProperties, setPickerTimeItemProperties, setSelectionRange, setSelectorFormat, setShowChooserFiscalYearPicker, setShowChooserWeekPicker, setShowPickerTimeItem, setStartDate, setTextAlign, setTextFieldProperties, setUse24HourTime, setUseMask, setUseSharedPicker, setYearSelectorProperties`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPickerIconClickHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, asSGWTComponent, blurItem, canEditCriterion, clearValue, disable, enable, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsString, getBrowserSpellCheck, getCanEdit, getCanFocus, getCanvasAutoChild, getCellHeight, getCellStyle, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getCriteriaField, getCriterion, getCriterion, getDataPath, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDisabled, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getFetchMissingValues, getFieldName, getFilterLocally, getForm, getFormItemAutoChild, getFullDataPath, getGlobalTabIndex, getHeight, getHint, getHintStyle, getHoverAlign, getHoverDelay, getHoverHeight, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getIcon, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIconVAlign, getIconWidth, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getLeft, getLocateItemBy, getMultipleValueSeparator, getName, getOperator, getOptionCriteria, getOptionFilterContext, getOptionOperationId, getPageLeft, getPageRect, getPageTop, getPicker, getPickerIconHeight, getPickerIconName, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconWidth, getPrintTextBoxStyle, getPrintTitleStyle, getPrompt, getReadOnlyDisplay, getReadOnlyTextBoxStyle, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRowSpan, getSaveOnEnter, getSelectedRecord, getSelectOnClick, getSelectOnFocus, getShouldSaveValue, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDisabled, getShowErrorIcon, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowOverIcons, getShowPickerIcon, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStopOnError, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextBoxStyle, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValue, getValueAsRecordList, getValueField, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getVisible, getVisibleHeight, getVisibleWidth, getWidth, getWrapTitle, hasAdvancedCriteria, hide, hideIcon, invalidateDisplayValueCache, isCreated, isDisabled, isDrawn, isVisible, redraw, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setBrowserSpellCheck, setCanEdit, setCanEditCriterionPredicate, setCanFocus, setCellHeight, setCellStyle, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setCriteriaField, setCriterion, setCriterionGetter, setCriterionSetter, setDataPath, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setFetchMissingValues, setFilterLocally, setGlobalTabIndex, setHeight, setHeight, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverHeight, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconVAlign, setIconWidth, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setLeft, setLocateItemBy, setMultipleValueSeparator, setName, setOperator, setOptionCriteria, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setPickerIconHeight, setPickerIconName, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintTextBoxStyle, setPrintTitleStyle, setPrompt, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyDisplay, setReadOnlyTextBoxStyle, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRowSpan, setSaveOnEnter, setSelectOnClick, setSelectOnFocus, setShouldSaveValue, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDisabled, setShowErrorIcon, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIfCondition, setShowOverIcons, setShowPickerIcon, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStopOnError, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextBoxStyle, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setWidth, setWidth, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, show, showIcon, showPicker, stopHover, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, getJsObj, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DateTimeItem

          public DateTimeItem()

    - #### DateTimeItem

          public DateTimeItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### DateTimeItem

          public DateTimeItem(java.lang.String name)

    - #### DateTimeItem

          public DateTimeItem(java.lang.String name,
                      java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static DateTimeItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `DateItem`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### setDisplayFormat

          public void setDisplayFormat(DateDisplayFormat displayFormat)

      This property can be used to customize the format in which datetimes are displayed.
      Should be set to a standard `DateDisplayFormat` or a function which will return a formatted date time string.

      If unset, the standard shortDateTime format as set up in `Date.setShortDatetimeDisplayFormat` will be used.

      NOTE: you may need to update the `inputFormat` to ensure the DateItem is able to parse user-entered date strings back into Dates

      Overrides:
        `setDisplayFormat` in class `FormItem`
      Parameters:
        `displayFormat` - displayFormat Default value is null
      See Also:
        `setInputFormat(java.lang.String)`

    - #### getDisplayFormat

          public DateDisplayFormat getDisplayFormat()

      This property can be used to customize the format in which datetimes are displayed.
      Should be set to a standard `DateDisplayFormat` or a function which will return a formatted date time string.

      If unset, the standard shortDateTime format as set up in `Date.setShortDatetimeDisplayFormat` will be used.

      NOTE: you may need to update the `inputFormat` to ensure the DateItem is able to parse user-entered date strings back into Dates

      Returns:
        DateDisplayFormat
      See Also:
        `getInputFormat()`

    - #### setInputFormat

          public void setInputFormat(java.lang.String inputFormat)

      If `useTextField` is `true` this property can be used to specify the input format for date strings. If unset, the input format will be determined based on the specified `dateFormtter` if possible (see `DateItem.getInputFormat`), otherwise picked up from the Date class (see `Date.setInputFormat`).

      Should be set to a standard DateInputFormat

      Note that the DateInputFormat property is sufficient to parse date or datetime strings specified in most standard date formats. However should an entirely custom parsing function be required developers can apply a custom `editorValueParser` function.

      Overrides:
        `setInputFormat` in class `DateItem`
      Parameters:
        `inputFormat` - . See `DateInputFormat`. Default value is null
      See Also:
        `FormItem.setDisplayFormat(com.smartgwt.client.types.DateDisplayFormat)`

    - #### getInputFormat

          public java.lang.String getInputFormat()

      If `useTextField` is `true` this property can be used to specify the input format for date strings. If unset, the input format will be determined based on the specified `dateFormtter` if possible (see `DateItem.getInputFormat`), otherwise picked up from the Date class (see `Date.setInputFormat`).

      Should be set to a standard DateInputFormat

      Note that the DateInputFormat property is sufficient to parse date or datetime strings specified in most standard date formats. However should an entirely custom parsing function be required developers can apply a custom `editorValueParser` function.

      Overrides:
        `getInputFormat` in class `DateItem`
      Returns:
        . See `DateInputFormat`
      See Also:
        `com.smartgwt.client.widgets.form.fields.DateItem#getDisplayFormat`

    - #### setUseTextField

          public void setUseTextField(java.lang.Boolean useTextField)

      DateTimeItems show datetime values in a freeform text entry area.
      Overrides:
        `setUseTextField` in class `DateItem`
      Parameters:
        `useTextField` - useTextField Default value is true
      See Also:
        `Basics overview and related methods`

    - #### getUseTextField

          public java.lang.Boolean getUseTextField()

      DateTimeItems show datetime values in a freeform text entry area.
      Overrides:
        `getUseTextField` in class `DateItem`
      Returns:
        Boolean
      See Also:
        `Basics overview and related methods`

    - #### setDefaultProperties

          public static void setDefaultProperties(DateTimeItem dateTimeItemProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `dateTimeItemProperties` - properties that should be used as new defaults when instances of this class are created